## notcurses 1.7.4+dfsg.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)
project(notcurses VERSION 1.7.4
  DESCRIPTION "Blingful UI for modern terminal emulators"
  HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
  LANGUAGES C CXX)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

include(CTest)
include(GNUInstallDirs)
include(CMakeDependentOption)
include(FeatureSummary)

###################### USER-SELECTABLE OPTIONS ###########################
# BUILD_TESTING is defined by CTest
option(DFSG_BUILD "DFSG build (no non-free media/code)" OFF)
option(USE_COVERAGE "Assess code coverage with llvm-cov/lcov" OFF)
cmake_dependent_option(
  USE_DOCTEST "Build notcurses-tester with doctest" ON
  "${BUILD_TESTING}" OFF
)
option(USE_DOXYGEN "Build HTML cross reference with doxygen" OFF)
option(USE_PANDOC "Build man pages and HTML reference with pandoc" ON)
option(USE_POC "Build small, uninstalled proof-of-concept binaries" ON)
option(USE_QRCODEGEN "Disable libqrcodegen QR code support" ON)
option(USE_STATIC "Build static libraries (in addition to shared)" ON)
set(USE_MULTIMEDIA "ffmpeg" CACHE STRING "Multimedia engine, one of 'ffmpeg', 'oiio', or 'none'")
set_property(CACHE USE_MULTIMEDIA PROPERTY STRINGS ffmpeg oiio none)
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo Coverage)
############## END (additional) USER-SELECTABLE OPTIONS ##################
set(USE_FFMPEG OFF)
set(USE_OIIO OFF)
if(${USE_MULTIMEDIA} STREQUAL "ffmpeg")
  set(USE_FFMPEG ON)
elseif(${USE_MULTIMEDIA} STREQUAL "oiio")
  set(USE_OIIO ON)
elseif(NOT ${USE_MULTIMEDIA} STREQUAL "none")
  message(FATAL_ERROR "USE_MULTIMEDIA must be one of 'oiio', 'ffmpeg', 'none' (was '${USE_MULTIMEDIA}')")
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE
    STRING "Choose the build mode." FORCE)
endif()
string(APPEND CMAKE_C_FLAGS_DEBUG " -O0")
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -O0")
if("${USE_COVERAGE}")
  if(NOT "${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message(FATAL_ERROR "USE_COVERAGE was on but CC isn't clang")
  endif()
  if(NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message(FATAL_ERROR "USE_COVERAGE was on but CXX isn't clang++")
  endif()
  # FIXME requires clang11+
  string(APPEND CMAKE_C_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
  string(APPEND CMAKE_CXX_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
endif()

# global compiler flags
add_compile_definitions(FORTIFY_SOURCE=2)
add_compile_options(-Wall -Wextra -W -Wshadow -Wformat -fexceptions)

message(STATUS "Requested multimedia engine: ${USE_MULTIMEDIA}")
message(STATUS "Requested build mode: ${CMAKE_BUILD_TYPE}")

find_package(PkgConfig REQUIRED)
# don't use REQUIRED with subsequent find_package() operations; we use
# feature_summary + set_package_properties to fail in one fell swoop.
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)
# some distros (<cough>motherfucking alpine</cough> subsume terminfo directly
# into ncurses. accept either, and may god have mercy on our souls.
pkg_search_module(TERMINFO REQUIRED tinfo>=6.1 ncursesw>=6.1)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND terminfo)
set_package_properties(terminfo PROPERTIES TYPE REQUIRED)
if(${USE_FFMPEG})
pkg_check_modules(AVCODEC REQUIRED libavcodec>=57.0)
pkg_check_modules(AVFORMAT REQUIRED libavformat>=57.0)
pkg_check_modules(AVUTIL REQUIRED libavutil>=56.0)
pkg_check_modules(SWSCALE REQUIRED libswscale>=5.0)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND FFMpeg)
elseif(${USE_OIIO})
pkg_check_modules(OIIO REQUIRED OpenImageIO>=2.1)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND OpenImageIO)
endif()
find_library(MATH_LIBRARIES m)
if(${USE_DOCTEST})
find_package(doctest 2.3.5)
set_package_properties(doctest PROPERTIES TYPE REQUIRED)
endif()

# don't cache these, or installing them requires clearing the cache to be found.
# this is going to be true for anything lacking pkg-config/CMake support.
unset(HAVE_UNISTRING_H CACHE)
check_include_file("uniwbrk.h" HAVE_UNISTRING_H)
if(NOT "${HAVE_UNISTRING_H}")
  message(FATAL_ERROR "Couldn't find uniwbrk.h from GNU libunistring")
endif()
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND libunistring)
set_package_properties(libunistring PROPERTIES TYPE REQUIRED)
unset(HAVE_QRCODEGEN_H CACHE)
if("${USE_QRCODEGEN}")
check_include_file("qrcodegen/qrcodegen.h" HAVE_QRCODEGEN_H)
if(NOT "${HAVE_QRCODEGEN_H}")
  message(FATAL_ERROR "USE_QRCODEGEN is active, but couldn't find qrcodegen.h")
endif()
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND qrcodegen)
endif()
find_library(LIBRT rt)

# libnotcurses (core shared library, core static library)
file(GLOB NCSRCS CONFIGURE_DEPENDS src/lib/*.c src/lib/*.cpp)
add_library(notcurses SHARED ${NCSRCS})
if(${USE_STATIC})
add_library(notcurses-static STATIC ${NCSRCS})
else()
add_library(notcurses-static STATIC EXCLUDE_FROM_ALL ${NCSRCS})
endif()
set_target_properties(
  notcurses-static PROPERTIES
  OUTPUT_NAME notcurses
)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

set_target_properties(notcurses PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
set_target_properties(notcurses-static PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
target_include_directories(notcurses
  PRIVATE
    include
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
)
target_include_directories(notcurses-static
  PRIVATE
    include
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_STATIC_INCLUDE_DIRS}"
)
target_link_libraries(notcurses
  PRIVATE
    "${TERMINFO_LIBRARIES}"
    "${LIBRT}"
    unistring
  PUBLIC
    Threads::Threads
)
target_link_libraries(notcurses-static
  PRIVATE
    "${TERMINFO_STATIC_LIBRARIES}"
    "${LIBRT}"
    unistring
  PUBLIC
    Threads::Threads
)
target_link_directories(notcurses
  PRIVATE
    "${TERMINFO_LIBRARY_DIRS}"
)
target_link_directories(notcurses-static
  PRIVATE
    "${TERMINFO_STATIC_LIBRARY_DIRS}"
)

if(${USE_QRCODEGEN})
target_link_libraries(notcurses PRIVATE qrcodegen)
target_link_libraries(notcurses-static PRIVATE qrcodegen)
endif()

if(${USE_FFMPEG})
target_include_directories(notcurses
  PUBLIC
    "${AVCODEC_INCLUDE_DIRS}"
    "${AVFORMAT_INCLUDE_DIRS}"
    "${AVUTIL_INCLUDE_DIRS}"
    "${SWSCALE_INCLUDE_DIRS}"
)
target_include_directories(notcurses-static
  PUBLIC
    "${AVCODEC_STATIC_INCLUDE_DIRS}"
    "${AVFORMAT_STATIC_INCLUDE_DIRS}"
    "${AVUTIL_STATIC_INCLUDE_DIRS}"
    "${SWSCALE_STATIC_INCLUDE_DIRS}"
)
target_link_libraries(notcurses
  PRIVATE
    "${AVCODEC_LIBRARIES}"
    "${AVFORMAT_LIBRARIES}"
    "${SWSCALE_LIBRARIES}"
  PUBLIC
    "${AVUTIL_LIBRARIES}"
)
target_link_libraries(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_LIBRARIES}"
    "${AVFORMAT_STATIC_LIBRARIES}"
    "${SWSCALE_STATIC_LIBRARIES}"
  PUBLIC
    "${AVUTIL_STATIC_LIBRARIES}"
)
target_link_directories(notcurses
  PRIVATE
    "${AVCODEC_LIBRARY_DIRS}"
    "${AVFORMAT_LIBRARY_DIRS}"
    "${SWSCALE_LIBRARY_DIRS}"
  PUBLIC
    "${AVUTIL_LIBRARY_DIRS}"
)
target_link_directories(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_LIBRARY_DIRS}"
    "${AVFORMAT_STATIC_LIBRARY_DIRS}"
    "${SWSCALE_STATIC_LIBRARY_DIRS}"
  PUBLIC
    "${AVUTIL_STATIC_LIBRARY_DIRS}"
)
elseif(${USE_OIIO})
target_include_directories(notcurses PUBLIC "${OIIO_INCLUDE_DIRS}")
target_include_directories(notcurses-static PUBLIC "${OIIO_STATIC_INCLUDE_DIRS}")
target_link_libraries(notcurses PRIVATE ${OIIO_LIBRARIES})
target_link_libraries(notcurses-static PRIVATE ${OIIO_STATIC_LIBRARIES})
target_link_directories(notcurses PRIVATE ${OIIO_LIBRARY_DIRS})
target_link_directories(notcurses-static PRIVATE ${OIIO_STATIC_LIBRARY_DIRS})
endif()

# don't want these on freebsd
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
target_compile_definitions(notcurses
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
target_compile_definitions(notcurses-static
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
set(PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
set(PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig")
endif()

# libnotcurses++
set(NCPP_SOURCES
  src/libcpp/FDPlane.cc
  src/libcpp/Menu.cc
  src/libcpp/MultiSelector.cc
  src/libcpp/NotCurses.cc
  src/libcpp/Plane.cc
  src/libcpp/Plot.cc
  src/libcpp/Reel.cc
  src/libcpp/Root.cc
  src/libcpp/Selector.cc
  src/libcpp/Subproc.cc
  src/libcpp/Tablet.cc
  src/libcpp/Utilities.cc
  )

add_library(notcurses++ SHARED ${NCPP_SOURCES})
if(${USE_STATIC})
add_library(notcurses++-static STATIC ${NCPP_SOURCES})
else()
add_library(notcurses++-static STATIC EXCLUDE_FROM_ALL ${NCPP_SOURCES})
endif()
set_target_properties(
  notcurses++-static PROPERTIES
  OUTPUT_NAME notcurses++
  )

set_target_properties(
  notcurses++ PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
  OUTPUT_NAME "notcurses++")

set(NCPP_INCLUDE_DIRS
  include
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
  )

target_include_directories(notcurses++
  PRIVATE ${NCPP_INCLUDE_DIRS}
  )

target_include_directories(notcurses++-static
  PRIVATE ${NCPP_INCLUDE_DIRS}
  )

target_link_libraries(notcurses++
  PUBLIC
  notcurses)

set(NCPP_COMPILE_OPTIONS
  -Werror=format-security
  -Wnull-dereference
  -Wunused
  -Wno-c99-extensions
  -fno-strict-aliasing
  -ffunction-sections
  -fstack-protector
  -fno-rtti
  -fpic
  )

set(NCPP_COMPILE_DEFINITIONS_PUBLIC
  _GNU_SOURCE _DEFAULT_SOURCE
  )

target_compile_options(notcurses++
  PRIVATE
  ${NCPP_COMPILE_OPTIONS}
  )

target_compile_options(notcurses++-static
  PRIVATE
  ${NCPP_COMPILE_OPTIONS}
  )

target_compile_definitions(notcurses++
  PUBLIC
    ${NCPP_COMPILE_DEFINITIONS_PUBLIC}
  )

target_compile_definitions(notcurses++-static
  PUBLIC
    ${NCPP_COMPILE_DEFINITIONS_PUBLIC}
  )

file(GLOB NOTCURSES_HEADERS
  CONFIGURE_DEPENDS
  LIST_DIRECTORIES false
  ${PROJECT_SOURCE_DIR}/include/notcurses/*.h)

file(GLOB NCPP_HEADERS
  CONFIGURE_DEPENDS
  LIST_DIRECTORIES false
  ${PROJECT_SOURCE_DIR}/include/ncpp/*.hh)

file(GLOB NCPP_INTERNAL_HEADERS
  CONFIGURE_DEPENDS
  LIST_DIRECTORIES false
  ${PROJECT_SOURCE_DIR}/include/ncpp/internal/*.hh)

export(PACKAGE notcurses)

install(FILES ${NOTCURSES_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/notcurses)
install(FILES ${NCPP_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ncpp)
install(FILES ${NCPP_INTERNAL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ncpp/internal)

# notcurses-demo
file(GLOB DEMOSRCS CONFIGURE_DEPENDS src/demo/*.c)
add_executable(notcurses-demo ${DEMOSRCS})
target_compile_definitions(notcurses-demo
  PRIVATE
    _GNU_SOURCE
)
target_include_directories(notcurses-demo
  PRIVATE
    include
    "${PROJECT_BINARY_DIR}/include"
  PUBLIC
    "${AVCODEC_INCLUDE_DIRS}"
    "${AVFORMAT_INCLUDE_DIRS}"
    "${AVUTIL_INCLUDE_DIRS}"
    "${SWSCALE_INCLUDE_DIRS}"
)
target_link_libraries(notcurses-demo
  PRIVATE
    notcurses
    unistring
    ${MATH_LIBRARIES}
)

# tiny proofs of concept, one binary per source file
if(USE_POC)
file(GLOB POCSRCS CONFIGURE_DEPENDS src/poc/*.c src/poc/*.cpp)
foreach(f ${POCSRCS})
  get_filename_component(fe "${f}" NAME_WE)
  add_executable(${fe} ${f})
  target_include_directories(${fe}
    PRIVATE include "${TERMINFO_INCLUDE_DIRS}"
    "${PROJECT_BINARY_DIR}/include"
  )
  target_link_libraries(${fe}
    PRIVATE notcurses++ "${TERMINFO_LIBRARIES}"
  )
  target_link_directories(${fe}
    PRIVATE "${TERMINFO_LIBRARY_DIRS}"
  )
endforeach()
endif()

# Pandoc documentation (man pages, HTML reference)
if(USE_PANDOC)

=== debian/changelog ===
notcurses (1.7.4+dfsg.1-2) unstable; urgency=medium

  * New upstream version
  * Update libnotcurses1.symbols
  * Export TERM in CI scripts, fixing salsa CI build

 -- Nick Black <dankamongmen@gmail.com>  Mon, 21 Sep 2020 23:44:21 -0400

notcurses (1.7.3+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Sat, 19 Sep 2020 21:36:29 -0400

notcurses (1.7.2+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Merge salsa CI scripts

 -- Nick Black <dankamongmen@gmail.com>  Thu, 10 Sep 2020 04:55:13 -0400

notcurses (1.7.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version, fixes abort in DFSG build

 -- Nick Black <dankamongmen@gmail.com>  Mon, 31 Aug 2020 21:53:23 -0400

notcurses (1.7.0+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Add José Luis Cruz to copyright

 -- Nick Black <dankamongmen@gmail.com>  Sun, 30 Aug 2020 20:42:28 -0400

notcurses (1.6.20+dfsg.1-1) unstable; urgency=medium

  * New upstream release (RC for 1.7.0)
  * Add new symbols ncplane_y and ncplane_x
  * debian/rules: USE_POC=off for faster builds

 -- Nick Black <dankamongmen@gmail.com>  Sun, 30 Aug 2020 01:27:54 -0400

notcurses (1.6.19+dfsg.1-1) unstable; urgency=medium

  * Added -fdebug-prefix-map=$(CURDIR)=/ to CFLAGS with the goal of
    (more) reproducible builds
  * New upstream version, add new symbols
  * Update Vcs links to debian/notcurses from nickblack/notcurses
  * Remove unnecessary Testsuite line from control
  * Critical fixes for s390 / other big-endian arches

 -- Nick Black <dankamongmen@gmail.com>  Thu, 27 Aug 2020 12:45:12 -0400

notcurses (1.6.11+dfsg.1-1) unstable; urgency=medium

  * Add Breaks+Replaces for notcurses-bin << 1.6 (Closes: #966500)
  * New notcurses-demo phase "zoo" available
  * Add python3-pypandoc dependency
  * Don't install notcurses-pydemo nor notcurses-pydemo.1 as part of
    notcurses-bin; these both belong in python3-notcurses.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 03 Aug 2020 02:56:22 -0400

notcurses (1.6.9+dfsg.1-2) unstable; urgency=medium

  * Move to salsa.debian.org
  * Set TERM=xterm for dh_auto_test. This is only until upstream
    teaches CMake to check for TERM before launching certain tests.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 27 Jul 2020 01:06:17 -0400

notcurses (1.6.9+dfsg.1-1) unstable; urgency=medium

  * Add dependency on libunistring-dev
  * Add debian/tests for autopkgtests (demo, unit tests)
  * Install new documentation TERMS.md
  * New upstream release, with new binary 'ncneofetch'
  * Remove -DUSE_PYTHON, no longer used

 -- Nick Black <dankamongmen@gmail.com>  Sun, 26 Jul 2020 23:31:14 -0400

notcurses (1.5.1+dfsg.1-1) unstable; urgency=medium

  * New upstream release, with new demo "dragon"

 -- Nick Black <dankamongmen@gmail.com>  Sun, 14 Jun 2020 17:22:05 -0400

notcurses (1.5.0+dfsg.1-1) unstable; urgency=medium

  * New upstream release

 -- Nick Black <dankamongmen@gmail.com>  Mon, 08 Jun 2020 22:29:03 -0400

notcurses (1.4.5+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Properly build Python on i386
  * Bump symbol versions for ncvisual_* functions with changed API
  * Debhelper compat level 13
  * Declare conformance with Debian policy 4.5.0.2

 -- Nick Black <dankamongmen@gmail.com>  Fri, 05 Jun 2020 06:30:32 -0400

notcurses (1.4.3+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Fri, 22 May 2020 09:20:16 -0400

notcurses (1.4.2.3+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Sun, 17 May 2020 09:05:08 -0400

notcurses (1.4.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version, fixed unit tests on some geometries

 -- Nick Black <dankamongmen@gmail.com>  Sun, 10 May 2020 23:20:42 -0400

notcurses (1.4.0+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Install USAGE and other docs in libnotcurses-dev

 -- Nick Black <dankamongmen@gmail.com>  Sun, 10 May 2020 21:41:10 -0400

notcurses (1.3.4+dfsg.1-1) unstable; urgency=medium

  * Updated Vcs-Browser/Vcs-Git to point at extracted packaging.
  * Add python3-pip to BuildDepends, eliminating warning.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 07 May 2020 01:53:23 -0400

notcurses (1.3.3+dfsg.1-1) unstable; urgency=medium

  * Explicitly supply -DUSE_MULTIMEDIA=ffmpeg to CMake
  * Add libqrcodegen-dev build-dependency

 -- Nick Black <dankamongmen@gmail.com>  Sun, 26 Apr 2020 21:28:21 -0400

notcurses (1.3.2+dfsg.1-1) unstable; urgency=medium

  * New upstream release
  * Prune unnecessary keys off of upstream/signing-key.asc

 -- Nick Black <dankamongmen@gmail.com>  Sun, 19 Apr 2020 15:57:51 -0400

notcurses (1.3.1+dfsg.1-2) unstable; urgency=medium

  * Bump all symbol version numbers to 1.3.1, "first released"
      debian package

 -- Nick Black <dankamongmen@gmail.com>  Sat, 18 Apr 2020 03:29:22 -0400

notcurses (1.3.1+dfsg.1-1) unstable; urgency=medium

  * Updates per MTecknology's review: +dfsg in version, uscan
      DFSG repack, upstream/metadata, README.source, sig check
  * Initial release (Closes: #950492)

 -- Nick Black <dankamongmen@gmail.com>  Sat, 18 Apr 2020 03:14:36 -0400

=== debian/control ===
Source: notcurses
Priority: optional
Maintainer: Nick Black <dankamongmen@gmail.com>
Build-Depends: cmake (>= 3.16),
               debhelper-compat (= 13),
               dh-python (>= 4.20191017),
               dh-sequence-python3,
               doctest-dev,
               libavformat-dev (>= 7:4.2.1),
               libavutil-dev (>= 7:4.2.1),
               libncurses-dev,
               libqrcodegen-dev (>= 1.5.0),
               libswscale-dev (>= 7:4.2.1),
               libunistring-dev,
               pandoc (>= 1.19.2.4),
               pkg-config,
               python3-cffi (>= 1.13.2),
               python3-dev,
               python3-pip (>= 20.1),
               python3-pypandoc,
               python3-setuptools (>= 44.0.0)
Standards-Version: 4.5.0.2
Section: libs
X-Python3-Version: >= 3.7
Rules-Requires-Root: no
Homepage: https://nick-black.com/dankwiki/index.php/Notcurses
Vcs-Browser: https://salsa.debian.org/debian/notcurses
Vcs-Git: https://salsa.debian.org/debian/notcurses.git

Package: libnotcurses++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnotcurses++1 (= ${binary:Version}),
         libnotcurses-dev (>= ${binary:Version}),
         ${misc:Depends}
Description: Character graphics and TUI library (C++ development)
 notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for C++ development using notcurses.

Package: libnotcurses++1
Architecture: any
Multi-Arch: same
Recommends: ncurses-term
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Character graphics and TUI library (C++ wrappers)
 notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files underlie the C++ wrappers for notcurses.

Package: libnotcurses-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libavformat-dev,
         libncurses-dev,
         libnotcurses1 (= ${binary:Version}),
         ${misc:Depends}
Description: Character graphics and TUI library (development)
 notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 These files are necessary for C development using notcurses.

Package: libnotcurses1
Architecture: any
Multi-Arch: same
Recommends: ncurses-term
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Character graphics and TUI library
 notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.

Package: notcurses-bin
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends: desktop-base,
         ncurses-term,
         notcurses-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: python3-notcurses (>= ${source:Version})
Description: Character graphics and TUI library demos
 notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These utilities from the notcurses project include notcurses-demo
 (a demonstration of various libnotcurses capabilities) and
 notcurses-view (a character mode multimedia player), among other
 tools. Unit tests are furthermore bundled as notcurses-tester.

Package: notcurses-data
Architecture: all
Multi-Arch: foreign
Section: graphics
Depends: ncurses-term, ${misc:Depends}
Description: Multimedia used by notcurses-bin
 notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 This package contains multimedia used by notcurses-demo
 and notcurses-tester from the notcurses-bin package.

Package: python3-notcurses
Section: python
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Replaces: notcurses-bin (<< 1.6)
Breaks: notcurses-bin (<< 1.6)
Description: Character graphics and TUI library (Python)
 notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for Python development using notcurses.
 The notcurses-pydemo script verifies these Python wrappers.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=notcurses
export PYBUILD_DIR=python
export PYBUILD_DESTDIR=debian/python3-notcurses

CFLAGS += -ffile-prefix-map=$(CURDIR)=/ -fdebug-prefix-map=$(CURDIR)=/

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DDFSG_BUILD=on -DUSE_POC=off

override_dh_auto_build:
	dh_auto_build
	CFLAGS="$(CFLAGS) -I$(CURDIR)/include" LDFLAGS="$(LDFLAGS) \
		-L$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)" pybuild --build

override_dh_auto_install:
	dh_auto_install -B $(BUILDDIR)
	pybuild --install

## notcurses 1.7.6+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 1.7.4
+project(notcurses VERSION 1.7.6
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (1.7.6+dfsg.1-2) unstable; urgency=medium

  [ Nick Black ]
  * Build in pbuilder to avoid picking up libav-extra, argh

 -- Nick Black <dankamongmen@gmail.com>  Tue, 13 Oct 2020 18:41:52 -0400

notcurses (1.7.6+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Install CONTRIBUTING.md

 -- Nick Black <dankamongmen@gmail.com>  Fri, 09 Oct 2020 20:08:34 -0400

notcurses (1.7.5+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * notcurses-ncreel is no longer installed

 -- Nick Black <dankamongmen@gmail.com>  Tue, 29 Sep 2020 13:14:57 -0400

=== debian/control ===
--- 
+++ 
@@ -88,11 +88,11 @@
 Multi-Arch: foreign
 Section: graphics
 Depends: desktop-base,
-         ncurses-term,
          notcurses-data (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: python3-notcurses (>= ${source:Version})
+Recommends: ncurses-term,
+            python3-notcurses (>= ${source:Version})
 Description: Character graphics and TUI library demos
  notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
@@ -107,7 +107,8 @@
 Architecture: all
 Multi-Arch: foreign
 Section: graphics
-Depends: ncurses-term, ${misc:Depends}
+Depends: ${misc:Depends}
+Recommends: ncurses-term
 Description: Multimedia used by notcurses-bin
  notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents

## notcurses 2.0.4+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 1.7.6
+project(notcurses VERSION 2.0.4
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -132,7 +132,6 @@
 )
 set_target_properties(notcurses-static PROPERTIES
   VERSION ${PROJECT_VERSION}
-  SOVERSION ${PROJECT_VERSION_MAJOR}
 )
 target_include_directories(notcurses
   PRIVATE
@@ -341,7 +340,8 @@
 file(GLOB NOTCURSES_HEADERS
   CONFIGURE_DEPENDS
   LIST_DIRECTORIES false
-  ${PROJECT_SOURCE_DIR}/include/notcurses/*.h)
+  ${PROJECT_SOURCE_DIR}/include/notcurses/*.h
+  ${CMAKE_CURRENT_BINARY_DIR}/include/version.h)
 
 file(GLOB NCPP_HEADERS
   CONFIGURE_DEPENDS

=== debian/changelog ===
notcurses (2.0.4+dfsg.1-1) unstable; urgency=medium

  * New upstream version, fixes unit tests for non-UTF8

 -- Nick Black <dankamongmen@gmail.com>  Tue, 10 Nov 2020 10:52:48 -0500

notcurses (2.0.3+dfsg.1-1) unstable; urgency=medium

  * New upstream version, including 3x2 sexblitter

 -- Nick Black <dankamongmen@gmail.com>  Mon, 09 Nov 2020 13:47:32 -0500

notcurses (2.0.2+dfsg.1-2) unstable; urgency=medium

  * New upstream version:
   * The Notcurses API is now considered stable. Backwards
     compatibility will be maintained henceforth.
   * soname bump 1->2 (patched to remain 1)
   * Adds ncvisual_render_loop()
   * Quadblitter perf+transparency improvements
   * Adds ncmenu_item_set_status()
  * Upload to experimental to begin ABI transition
  * Relax ncurses-term to Recommends: from Depends:
  * Add package-does-not-install-examples lintian override for rust
  * Add application-in-library-section lintian override for python

 -- Nick Black <dankamongmen@gmail.com>  Sat, 07 Nov 2020 00:34:34 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: notcurses
 Priority: optional
 Maintainer: Nick Black <dankamongmen@gmail.com>
-Build-Depends: cmake (>= 3.16),
+Build-Depends: cmake (>= 3.14),
                debhelper-compat (= 13),
                dh-python (>= 4.20191017),
                dh-sequence-python3,
@@ -19,7 +19,7 @@
                python3-pip (>= 20.1),
                python3-pypandoc,
                python3-setuptools (>= 44.0.0)
-Standards-Version: 4.5.0.2
+Standards-Version: 4.5.0
 Section: libs
 X-Python3-Version: >= 3.7
 Rules-Requires-Root: no
@@ -35,11 +35,11 @@
          libnotcurses-dev (>= ${binary:Version}),
          ${misc:Depends}
 Description: Character graphics and TUI library (C++ development)
- notcurses facilitates the creation of modern TUI programs,
+ Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
  an API similar to that of Curses, and rides atop Terminfo.
  .
- These files are necessary for C++ development using notcurses.
+ These files are necessary for C++ development using Notcurses.
 
 Package: libnotcurses++1
 Architecture: any
@@ -47,11 +47,11 @@
 Recommends: ncurses-term
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Character graphics and TUI library (C++ wrappers)
- notcurses facilitates the creation of modern TUI programs,
+ Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
  an API similar to that of Curses, and rides atop Terminfo.
  .
- These files underlie the C++ wrappers for notcurses.
+ These files underlie the C++ wrappers for Notcurses.
 
 Package: libnotcurses-dev
 Section: libdevel
@@ -62,13 +62,13 @@
          libnotcurses1 (= ${binary:Version}),
          ${misc:Depends}
 Description: Character graphics and TUI library (development)
- notcurses facilitates the creation of modern TUI programs, making
+ Notcurses facilitates the creation of modern TUI programs, making
  full use of Unicode and 24-bit TrueColor. Its API is similar
  to that of NCURSES, but extends that with z-buffering, rendering
  of images and video using ffmpeg, alpha blending, widgets, palette
  fades, resize awareness, and multithreading support.
  .
- These files are necessary for C development using notcurses.
+ These files are necessary for C development using Notcurses.
 
 Package: libnotcurses1
 Architecture: any
@@ -77,7 +77,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Character graphics and TUI library
- notcurses facilitates the creation of modern TUI programs, making
+ Notcurses facilitates the creation of modern TUI programs, making
  full use of Unicode and 24-bit TrueColor. Its API is similar
  to that of NCURSES, but extends that with z-buffering, rendering
  of images and video using ffmpeg, alpha blending, widgets, palette
@@ -94,11 +94,11 @@
 Recommends: ncurses-term,
             python3-notcurses (>= ${source:Version})
 Description: Character graphics and TUI library demos
- notcurses facilitates the creation of modern TUI programs,
+ Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
  an API similar to that of Curses, and rides atop Terminfo.
  .
- These utilities from the notcurses project include notcurses-demo
+ These utilities from the Notcurses project include notcurses-demo
  (a demonstration of various libnotcurses capabilities) and
  notcurses-view (a character mode multimedia player), among other
  tools. Unit tests are furthermore bundled as notcurses-tester.
@@ -110,7 +110,7 @@
 Depends: ${misc:Depends}
 Recommends: ncurses-term
 Description: Multimedia used by notcurses-bin
- notcurses facilitates the creation of modern TUI programs,
+ Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
  an API similar to that of Curses, and rides atop Terminfo.
  .
@@ -126,9 +126,9 @@
 Replaces: notcurses-bin (<< 1.6)
 Breaks: notcurses-bin (<< 1.6)
 Description: Character graphics and TUI library (Python)
- notcurses facilitates the creation of modern TUI programs,
+ Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
  an API similar to that of Curses, and rides atop Terminfo.
  .
- These files are necessary for Python development using notcurses.
+ These files are necessary for Python development using Notcurses.
  The notcurses-pydemo script verifies these Python wrappers.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+DEB_BUILD_MAINT_OPTIONS=reproducible=+fixfilepath
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export PYBUILD_NAME=notcurses

## notcurses 2.0.7+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
+# 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.0.4
+project(notcurses VERSION 2.0.7
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.0.7+dfsg.1-1) unstable; urgency=medium

  [ Nick Black ]
  * New upstream version
  * Mark two C++ symbols as optional so as to not upset Ubuntu build

 -- Nick Black <dankamongmen@gmail.com>  Sun, 22 Nov 2020 00:23:29 -0500

notcurses (2.0.4+dfsg.1-5) unstable; urgency=medium

  * Upload to unstable (Closes: 975029)

 -- Nick Black <dankamongmen@gmail.com>  Sat, 21 Nov 2020 20:03:55 -0500

notcurses (2.0.4+dfsg.1-4) experimental; urgency=medium

  * Rebuild against python 3.9
  * Debian policy 4.5.1

 -- Nick Black <dankamongmen@gmail.com>  Sat, 21 Nov 2020 00:35:21 -0500

notcurses (2.0.4+dfsg.1-3) experimental; urgency=medium

  [ Nick Black ]
  * Add Breaks/Replaces on libnotcurses1 and libnotcurses++1 >= 2.
    Thanks, Andreas Beckmann! (Closes: #974918)

 -- Nick Black <dankamongmen@gmail.com>  Mon, 16 Nov 2020 23:19:59 -0500

notcurses (2.0.4+dfsg.1-2) experimental; urgency=medium

  * Upload to experimental for soname 1->2 transition
  * Discard 0001-CMakeLists.txt-keep-soname-at-1.patch

 -- Nick Black <dankamongmen@gmail.com>  Sat, 14 Nov 2020 20:40:29 -0500

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
                python3-pip (>= 20.1),
                python3-pypandoc,
                python3-setuptools (>= 44.0.0)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: libs
 X-Python3-Version: >= 3.7
 Rules-Requires-Root: no
@@ -31,7 +31,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libnotcurses++1 (= ${binary:Version}),
+Depends: libnotcurses++2 (= ${binary:Version}),
          libnotcurses-dev (>= ${binary:Version}),
          ${misc:Depends}
 Description: Character graphics and TUI library (C++ development)
@@ -41,11 +41,13 @@
  .
  These files are necessary for C++ development using Notcurses.
 
-Package: libnotcurses++1
+Package: libnotcurses++2
 Architecture: any
 Multi-Arch: same
 Recommends: ncurses-term
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Replaces: libnotcurses++1 (>= 2)
+Breaks: libnotcurses++1 (>= 2)
 Description: Character graphics and TUI library (C++ wrappers)
  Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
@@ -59,7 +61,7 @@
 Multi-Arch: same
 Depends: libavformat-dev,
          libncurses-dev,
-         libnotcurses1 (= ${binary:Version}),
+         libnotcurses2 (= ${binary:Version}),
          ${misc:Depends}
 Description: Character graphics and TUI library (development)
  Notcurses facilitates the creation of modern TUI programs, making
@@ -70,12 +72,14 @@
  .
  These files are necessary for C development using Notcurses.
 
-Package: libnotcurses1
+Package: libnotcurses2
 Architecture: any
 Multi-Arch: same
 Recommends: ncurses-term
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Replaces: libnotcurses1 (>= 2)
+Breaks: libnotcurses1 (>= 2)
 Description: Character graphics and TUI library
  Notcurses facilitates the creation of modern TUI programs, making
  full use of Unicode and 24-bit TrueColor. Its API is similar

## notcurses 2.0.8+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.0.7
+project(notcurses VERSION 2.0.8
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.0.8+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Relax python-pip3 version dep

 -- Nick Black <dankamongmen@gmail.com>  Fri, 27 Nov 2020 16:59:03 -0500

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                pkg-config,
                python3-cffi (>= 1.13.2),
                python3-dev,
-               python3-pip (>= 20.1),
+               python3-pip (>= 20.0),
                python3-pypandoc,
                python3-setuptools (>= 44.0.0)
 Standards-Version: 4.5.1
@@ -48,12 +48,12 @@
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Replaces: libnotcurses++1 (>= 2)
 Breaks: libnotcurses++1 (>= 2)
-Description: Character graphics and TUI library (C++ wrappers)
+Description: Character graphics and TUI library (C++)
  Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
  an API similar to that of Curses, and rides atop Terminfo.
  .
- These files underlie the C++ wrappers for Notcurses.
+ These files are necessary for C++ development using Notcurses.
 
 Package: libnotcurses-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export PYBUILD_NAME=notcurses
-export PYBUILD_DIR=python
+export PYBUILD_DIR=cffi
 export PYBUILD_DESTDIR=debian/python3-notcurses
 
 CFLAGS += -ffile-prefix-map=$(CURDIR)=/ -fdebug-prefix-map=$(CURDIR)=/

## notcurses 2.0.9+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.0.8
+project(notcurses VERSION 2.0.9
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.0.9+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Fix for segfault on geometry change (2.0.8 regression)
  * Install new binary+manpage 'ncls'

 -- Nick Black <dankamongmen@gmail.com>  Tue, 01 Dec 2020 04:40:02 -0500

## notcurses 2.0.10+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.0.9
+project(notcurses VERSION 2.0.10
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -404,4 +404,3 @@
 endif()
 
 # Pandoc documentation (man pages, HTML reference)
-if(USE_PANDOC)

=== debian/changelog ===
notcurses (2.0.10+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Sun, 06 Dec 2020 13:23:38 -0500

## notcurses 2.0.11+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.0.10
+project(notcurses VERSION 2.0.11
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.0.11+dfsg.1-1) unstable; urgency=medium

  * New upstream version, fixes bugs on big-endian

 -- Nick Black <dankamongmen@gmail.com>  Wed, 09 Dec 2020 00:35:49 -0500

## notcurses 2.1.0+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.0.11
+project(notcurses VERSION 2.1.0
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -404,3 +404,4 @@
 endif()
 
 # Pandoc documentation (man pages, HTML reference)
+if(USE_PANDOC)

=== debian/changelog ===
notcurses (2.1.0+dfsg.1-1) unstable; urgency=medium

  * New upstream release

 -- Nick Black <dankamongmen@gmail.com>  Sun, 13 Dec 2020 03:06:25 -0500

notcurses (2.0.12+dfsg.1-1) unstable; urgency=medium

  * New upstream version, fixes column placement for EGCs with multiple
    printing glyphs, and issues on cascading resize notifications.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 12 Dec 2020 06:46:47 -0500

=== debian/control ===
--- 
+++ 
@@ -52,8 +52,6 @@
  Notcurses facilitates the creation of modern TUI programs,
  making full use of Unicode and 24-bit TrueColor. It presents
  an API similar to that of Curses, and rides atop Terminfo.
- .
- These files are necessary for C++ development using Notcurses.
 
 Package: libnotcurses-dev
 Section: libdevel

## notcurses 2.1.1+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.1.0
+project(notcurses VERSION 2.1.1
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.1.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version, with progress bar widget

 -- Nick Black <dankamongmen@gmail.com>  Wed, 16 Dec 2020 17:46:07 -0500

## notcurses 2.1.2+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.1.1
+project(notcurses VERSION 2.1.2
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.1.2+dfsg.1-1) unstable; urgency=medium

  * New upstream version. Unicode 13 sextants are now used for blitting
    on terminals known to support them properly; this includes Kitty and
    VTE-derived emulators (gnome-terminal, xfce4-terminal, etc.).

 -- Nick Black (Public gmail account) <dankamongmen@gmail.com>  Sat, 26 Dec 2020 19:26:48 -0500

## notcurses 2.1.3+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.1.2
+project(notcurses VERSION 2.1.3
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.1.3+dfsg.1-1) unstable; urgency=medium

  * New upstream version. Fixes segfault in 'fallin' demo.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 31 Dec 2020 03:00:40 -0500

## notcurses 2.1.4+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.1.3
+project(notcurses VERSION 2.1.4
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.1.4+dfsg.1-1) unstable; urgency=medium

  * New upstream version.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 03 Jan 2021 19:59:23 -0500

## notcurses 2.1.5+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.1.4
+project(notcurses VERSION 2.1.5
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -77,6 +77,9 @@
 pkg_search_module(TERMINFO REQUIRED tinfo>=6.1 ncursesw>=6.1)
 set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND terminfo)
 set_package_properties(terminfo PROPERTIES TYPE REQUIRED)
+pkg_search_module(READLINE REQUIRED readline>=8.0)
+set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND readline)
+set_package_properties(readline PROPERTIES TYPE REQUIRED)
 if(${USE_FFMPEG})
 pkg_check_modules(AVCODEC REQUIRED libavcodec>=57.0)
 pkg_check_modules(AVFORMAT REQUIRED libavformat>=57.0)
@@ -112,9 +115,11 @@
 endif()
 find_library(LIBRT rt)
 
+file(GLOB COMPATSRC CONFIGURE_DEPENDS src/compat/compat.c)
+
 # libnotcurses (core shared library, core static library)
 file(GLOB NCSRCS CONFIGURE_DEPENDS src/lib/*.c src/lib/*.cpp)
-add_library(notcurses SHARED ${NCSRCS})
+add_library(notcurses SHARED ${NCSRCS} ${COMPATSRC})
 if(${USE_STATIC})
 add_library(notcurses-static STATIC ${NCSRCS})
 else()
@@ -137,18 +142,23 @@
 target_include_directories(notcurses
   PRIVATE
     include
+    src
     "${PROJECT_BINARY_DIR}/include"
     "${TERMINFO_INCLUDE_DIRS}"
+    "${READLINE_INCLUDE_DIRS}"
 )
 target_include_directories(notcurses-static
   PRIVATE
     include
+    src
     "${PROJECT_BINARY_DIR}/include"
     "${TERMINFO_STATIC_INCLUDE_DIRS}"
+    "${READLINE_STATIC_INCLUDE_DIRS}"
 )
 target_link_libraries(notcurses
   PRIVATE
     "${TERMINFO_LIBRARIES}"
+    "${READLINE_LIBRARIES}"
     "${LIBRT}"
     unistring
   PUBLIC
@@ -157,6 +167,7 @@
 target_link_libraries(notcurses-static
   PRIVATE
     "${TERMINFO_STATIC_LIBRARIES}"
+    "${READLINE_STATIC_LIBRARIES}"
     "${LIBRT}"
     unistring
   PUBLIC
@@ -165,10 +176,12 @@
 target_link_directories(notcurses
   PRIVATE
     "${TERMINFO_LIBRARY_DIRS}"
+    "${READLINE_LIBRARY_DIRS}"
 )
 target_link_directories(notcurses-static
   PRIVATE
     "${TERMINFO_STATIC_LIBRARY_DIRS}"
+    "${READLINE_STATIC_LIBRARY_DIRS}"
 )
 
 if(${USE_QRCODEGEN})
@@ -248,6 +261,8 @@
 )
 set(PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
 elseif(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
+set(PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig")
+elseif(${CMAKE_SYSTEM_NAME} STREQUAL "DragonFly")
 set(PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig")
 endif()
 
@@ -362,7 +377,7 @@
 
 # notcurses-demo
 file(GLOB DEMOSRCS CONFIGURE_DEPENDS src/demo/*.c)
-add_executable(notcurses-demo ${DEMOSRCS})
+add_executable(notcurses-demo ${DEMOSRCS} ${COMPATSRC})
 target_compile_definitions(notcurses-demo
   PRIVATE
     _GNU_SOURCE
@@ -370,6 +385,7 @@
 target_include_directories(notcurses-demo
   PRIVATE
     include
+    src
     "${PROJECT_BINARY_DIR}/include"
   PUBLIC
     "${AVCODEC_INCLUDE_DIRS}"
@@ -381,27 +397,3 @@
   PRIVATE
     notcurses
     unistring
-    ${MATH_LIBRARIES}
-)
-
-# tiny proofs of concept, one binary per source file
-if(USE_POC)
-file(GLOB POCSRCS CONFIGURE_DEPENDS src/poc/*.c src/poc/*.cpp)
-foreach(f ${POCSRCS})
-  get_filename_component(fe "${f}" NAME_WE)
-  add_executable(${fe} ${f})
-  target_include_directories(${fe}
-    PRIVATE include "${TERMINFO_INCLUDE_DIRS}"
-    "${PROJECT_BINARY_DIR}/include"
-  )
-  target_link_libraries(${fe}
-    PRIVATE notcurses++ "${TERMINFO_LIBRARIES}"
-  )
-  target_link_directories(${fe}
-    PRIVATE "${TERMINFO_LIBRARY_DIRS}"
-  )
-endforeach()
-endif()
-
-# Pandoc documentation (man pages, HTML reference)
-if(USE_PANDOC)

=== debian/changelog ===
notcurses (2.1.5+dfsg.1-1) unstable; urgency=medium

  * New upstream version, "animate" demo replaces "allglyph".
  * Add libreadline-dev to Build-Depends.

 -- Nick Black <dankamongmen@gmail.com>  Fri, 15 Jan 2021 05:16:19 -0500

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                libavformat-dev (>= 7:4.2.1),
                libavutil-dev (>= 7:4.2.1),
                libncurses-dev,
+               libreadline-dev,
                libqrcodegen-dev (>= 1.5.0),
                libswscale-dev (>= 7:4.2.1),
                libunistring-dev,
